/*
 * pxwarp.c
 *
 * Copyright (C) 2007-2008  Joshua Hoblitt
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * program; see the file COPYING. If not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <ippdb.h>
#include <string.h>

#include "pxtools.h"
#include "pxwarp.h"

bool pxwarpRunSetState(pxConfig *config, psS64 warp_id, const char *state)
{
    PS_ASSERT_PTR_NON_NULL(state, false);

    // check that state is a valid string value
    if (!(
            (strncmp(state, "run", 4) == 0)
            || (strncmp(state, "stop", 5) == 0)
            || (strncmp(state, "reg", 4) == 0)
        )
    ) {
        psError(PS_ERR_UNKNOWN, false,
                "invalid warpRun state: %s", state);
        return false;
    }

    char *query = "UPDATE warpRun SET state = '%s' WHERE warp_id = %" PRId64;
    if (!p_psDBRunQuery(config->dbh, query, state, warp_id)) {
        psError(PS_ERR_UNKNOWN, false,
                "failed to change state for warp_id %" PRId64, warp_id);
        return false;
    }

    return true;
}


bool pxwarpQueueByCamID(pxConfig *config,
                    psS64 cam_id,
                    char *workdir,
                    char *dvodb,
                    char *tess_id,
                    char *end_stage)
{
    PS_ASSERT_PTR_NON_NULL(config, false);

    if (!warpRunInsert(config->dbh,
        0,          // ID
        "warp",     // mode
        "run",      // state
        workdir,
        "dirty",    // workdir_state
        dvodb,
        tess_id,
        end_stage,
        NULL        // registered
    )) {
        psError(PS_ERR_UNKNOWN, false, "database error");
        return true;
    }

    psS64 warp_id = psDBLastInsertID(config->dbh);

    // depend on the f-keys to make sure we have a valid cam_id
    if (!warpInputExpInsert(config->dbh,
        warp_id,
        cam_id,
        false       // magiced
    )) {
        psError(PS_ERR_UNKNOWN, false, "database error");
        return false;
    }

    return true;
}
